/*

circle mixin

*/
@mixin circle($size) {
  width: $size;
  height: $size;
  border-radius: 100%;
}

/*

color mixins

*/
@mixin lightenLinkColor($color) {
  color: $color;
  &:hover, &:active {
    color: lighten($color, 5%);
  }
}

@mixin lightenLinkBackgroundColor($color) {
  background-color: $color;
  &:hover, &:active {
    background-color: lighten($color, 5%);
  }
}

@mixin darkenLinkColor($color) {
  color: $color;
  &:hover, &:active {
    color: darken($color, 5%);
  }
}

@mixin darkenLinkBackgroundColor($color) {
  background-color: $color;
  &:hover, &:active {
    background-color: darken($color, 5%);
  }
}

@mixin linkNoChangeColor($color) {
  color: $color;
  &:hover, &:active {
    color: $color;
  }
}

@mixin linkChangeColor($color-01, $color-02) {
  color: $color-01;
  &:hover, &:active {
    color: $color-02;
  }
}

/*

positionen mixins

*/
@mixin absPosition($top: auto, $right: auto, $bottom: auto, $left: auto) {
  position: absolute;
  top: $top;
  right: $right;
  bottom: $bottom;
  left: $left;
}

@mixin centerCenterTranslate {
  position: absolute;
  left: 50%;
  top: 50%;
  transform: translate(-50%, -50%);
}

@mixin centerHorizontalTranslate {
  position: absolute;
  left: 50%;
  transform: translatex(-50%);
}

@mixin centerVerticalTranslate {
  position: absolute;
  top: 50%;
  transform: translatey(-50%);
}

@mixin marginCenter {
  margin-left: auto;
  margin-right: auto;
}

@mixin marginNull {
  margin-left: 0;
  margin-right: 0;
}

/*

text style mixins

*/
@mixin txtTransformUpper {
  text-transform: uppercase;
}

@mixin txtAlignCenter {
  text-align: center;
}

@mixin txtAlignJustify {
  text-align: justify;
}

@mixin txtAlignLeft {
  text-align: left;
}

@mixin txtAlignRight {
  text-align: right;
}

@mixin txtDecorationNone {
  text-decoration: none;
}

@mixin txtDecorationLine {
  text-decoration: underline;
}

/*

layout mixins

*/
@mixin inline {
  display: inline;
}

@mixin inlineBlock {
  display: inline-block;
}

@mixin block {
  display: block;
}

/*

clearfix mixins

*/
@mixin clearfix() {
  &:before,
  &:after {
    content: "";
    display: table;
  }
  &:after {
    clear: both;
  }
}

/*

shadows mixins

*/
@mixin shadow-01 {
  box-shadow: none;
}

@mixin shadow-02 {
  box-shadow: 0 2px 2px 0 rgba(0, 0, 0, 0.14), 0 1px 5px 0 rgba(0, 0, 0, 0.12), 0 3px 1px -2px rgba(0, 0, 0, 0.2);
}

@mixin shadow-03 {
  box-shadow: 0 4px 5px 0 rgba(0, 0, 0, 0.14), 0 1px 10px 0 rgba(0, 0, 0, 0.12), 0 2px 4px -1px rgba(0, 0, 0, 0.3);
}

@mixin shadow-04 {
  box-shadow: 0 6px 10px 0 rgba(0, 0, 0, 0.14), 0 1px 18px 0 rgba(0, 0, 0, 0.12), 0 3px 5px -1px rgba(0, 0, 0, 0.3);
}

@mixin shadow-05 {
  box-shadow: 0 8px 10px 1px rgba(0, 0, 0, 0.14), 0 3px 14px 2px rgba(0, 0, 0, 0.12), 0 5px 5px -3px rgba(0, 0, 0, 0.3);
}

@mixin shadow-06 {
  box-shadow: 0 16px 24px 2px rgba(0, 0, 0, 0.14), 0 6px 30px 5px rgba(0, 0, 0, 0.12), 0 8px 10px -5px rgba(0, 0, 0, 0.3);
}

// animation
@keyframes fadeIn {
  0% {
    opacity: 0
  }
  100% {
    opacity: 1
  }
}

%animated {
  animation-duration: .6s;
  animation-fill-mode: both
}

%fadeIn {
  animation-name: fadeIn
}

/*

fonts

*/
@mixin f_headline($size, $lh:1) {
  font: 400 normal #{$size}/#{$lh} $f_headline;
}

@mixin f_text_ep-bold($size, $lh:1) {
  font: 400 normal #{$size}/#{$lh} $f_text_ep-bold;
}

@mixin f_text_ep-light($size, $lh:1) {
  font: 300 normal #{$size}/#{$lh} $f_text_ep-light;
}

@mixin f_text_ep-lightItalic($size, $lh:1) {
  font: 300 italic #{$size}/#{$lh} $f_text_ep-lightItalic;
}

@mixin f_text_ep-roman($size, $lh:1) {
  font: 400 normal #{$size}/#{$lh} $f_text_ep-roman;
}

@mixin f_text_ep-romanItalic($size, $lh:1) {
  font: 400 italic #{$size}/#{$lh} $f_text_ep-romanItalic;
}

@mixin rippleEffect($color: $cl-black) {
  background-position: center;
  transition: background 0.9s;
  &:hover {
    background: lighten($color, 5%) radial-gradient(circle, transparent 1%, lighten($color, 15%) 1%) center/15000%;
  }
  &:active {
    background-color: lighten($color, 10%);
    background-size: 100%;
    transition: background 0s;
  }
}

@mixin pageTitle() {
  font-weight: bold;
  font-size: 30px;
}

@function em($pixels, $context: $browser-context) {
  @if (unitless($pixels)) {
    $pixels: $pixels * 1px;
  }
  @if (unitless($context)) {
    $context: $context * 1px;
  }
  @return $pixels / $context * 1em;
}


